Skip to content
Install
PUT
/deployments/{id}/build-config
curl --request PUT \
--url https://example.com/deployments/example/build-config \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '{ "buildCommand": "example", "builderOverride": "firecracker", "buildFromRoot": true, "buildType": "dockerfile", "buildWithDepot": true, "dockerfileTarget": "example", "framework": "example", "installCommand": "example", "outputDirectory": "example", "persistentBuildCache": true, "rootDirectory": "example", "startCommand": "example" }'

Auth: authenticated (scope: deploy)

id
required
string
Media typeapplication/json
object
buildCommand
string | null
builderOverride
string | null
Allowed values: firecracker kubernetes
buildFromRoot
boolean
buildType
string
Allowed values: dockerfile railpack
buildWithDepot
boolean
dockerfileTarget
string | null
framework
string | null
installCommand
string | null
outputDirectory
string | null
persistentBuildCache
boolean
rootDirectory
string | null
startCommand
string | null

OK

Media typeapplication/json
object
autoDeployBranch
string | null
autoDeployEnabled
boolean
autoDeployPaths
Array<string>
availableReplicas
required
number
buildCommand
string | null
builderOverride
string | null
Allowed values: firecracker kubernetes
buildError
string | null
buildFromRoot
boolean
buildLogs
string | null
buildStatus
required
string
buildStep
string | null
buildStepTimestamps
object | null
buildType
string
Allowed values: dockerfile railpack
buildWithDepot
boolean
composeServiceName
string | null
composeStackId
string | null
cpuRequestMilli
number | null
createdAt
required
string
createdBy
string | null
deployStrategy
string
Allowed values: rollingUpdate recreate blueGreen
detectedConfig
object | null
dockerfileHealthCheck
object
command
required
Array<string>
interval
number
retries
number
startPeriod
number
timeout
number
dockerfilePath
string | null
dockerfileTarget
string | null
effectiveImagePullPolicy

What the cluster is actually doing, after deriving. Render this.

string
Allowed values: Always IfNotPresent
environment
object
id
required
string
isDefault
required
boolean
name
required
string
slug
required
string
key
additional properties
environmentId
string | null
envVars
Array<object>
object
createdAt
required
string
deploymentId
required
string
id
required
string
key
required
string
secret
required
boolean
updatedAt
required
string
value
required
string | null
key
additional properties
framework
string | null
githubBranch
string | null
githubInstallationId
Any of:
string
githubRepo
string | null
healthCheckCommand
string | null
healthCheckEnabled
boolean
healthCheckInterval
number
healthCheckOverride
boolean
healthCheckPath
string | null
healthCheckPort
number | null
healthCheckRetries
number
healthCheckTimeout
number
healthCheckType
string
icon
string | null
id
required
string
image
string | null
imageHistory
Array<object>
object
branch
string | null
buildCompletedAt
string | null
buildLogs
string | null
buildStartedAt
string | null
commitAuthorName
string | null
commitAuthorUsername
string | null
commitMessage
string | null
commitSha
string | null
createdAt
required
string
deploymentId
string
id
required
string
image
required
string
isActive
required
boolean
tag
string
triggeredBy
object
firstName
string | null
id
required
string
lastName
string | null
username
string | null
key
additional properties
triggeredById
string | null
triggerType
string | null
key
additional properties
imagePullPolicy

The override. null means it is derived from the image tag.

string | null
Allowed values: Always IfNotPresent
ingresses
Array<object>
object
annotations
object | null
clusterIssuer
string | null
createdAt
string
deploymentId
string | null
entrypoints
Array<string>
environmentId
string | null
host
required
string
id
required
string
ingressClass
string | null
name
required
string
namespace
string
path
required
string
pathType
string
projectId
string
protectionBypassSecret
string | null
protectionMode
string
Allowed values: none password orchard
redirectStatus
Any of:
number
Allowed values: 301
redirectTarget
string | null
routes
Array<object>
object
path
required
string
serviceName
required
string
servicePort
required
number
key
additional properties
service
object
createdAt
required
string
deploymentId
required
string
domain
string | null
externalIp
string | null
id
required
string
internalUrl
string
internalUrls
Array<string>
name
required
string
nodePort
number | null
port
required
number
ports
Array<object>
object
id
required
string
name
string | null
nodePort
number | null
port
required
number
protocol
required
string
publicAddress
string | null
publicEnabled
boolean
publicPort
number | null
publicStatus
object
addresses
required
Array<string>
reason
required
string | null
state
required
string
Allowed values: ready pending failed unknown
serviceId
required
string
targetPort
required
number
key
additional properties
protocol
required
string
targetPort
required
number
type
required
string
Allowed values: internal external ingress
updatedAt
required
string
key
additional properties
serviceId
string | null
statusAddress
string | null
templateInstanceId
string | null
tlsEnabled
boolean
tlsHosts
Array<string>
tlsSecretName
string | null
updatedAt
string
url
string
key
additional properties
installCommand
string | null
livenessEnabled
boolean
memoryRequestBytes
Any of:
string
name
required
string
namespace
required
string
observedAt
string | null
outputDirectory
string | null
persistentBuildCache
boolean
pods
Array<object>
object
containers
Array<object>
object
image
string | null
init
boolean
lastTermination
object
exitCode
number | null
finishedAt
string | null
reason
required
string | null
key
additional properties
message
string | null
name
required
string
ready
boolean
reason
string | null
restartCount
number
startedAt
string | null
state
string
Allowed values: running waiting terminated unknown
key
additional properties
cpuUsage
number | null
createdAt
string | null
deletingAt
string | null
disruption
string | null
graceSeconds
number | null
id
string
ip
string | null
memoryUsage
number | null
name
required
string
nodeName
string | null
notReadySince
string | null
phase
string | null
podIp
string | null
probes
object
liveness
required
boolean
readiness
required
boolean
startup
required
boolean
readySince
string | null
reason
string | null
restartCount
number
revision
string | null
scheduled
boolean
schedulingMessage
string | null
slot
string | null
startTime
string | null
status
required
string
unschedulableSince
string | null
key
additional properties
project
object
id
required
string
name
required
string
organizationId
string
slug
string
key
additional properties
projectId
required
string
readinessEnabled
boolean
readyReplicas
number | null
replicas
required
number
rollout
object
available
required
number
currentRevision
required
string | null
desired
required
number
previous
object
createdAt
required
string | null
hash
required
string
image
required
string | null
number
required
number
ready
required
number
replicas
required
number
ready
required
number
reason
required
string | null
revisions
required
Array<object>
object
createdAt
required
string | null
hash
required
string
image
required
string | null
number
required
number
ready
required
number
replicas
required
number
state
required
string
Allowed values: stable progressing failed
updated
required
number
rootDirectory
string | null
services
Array<object>
object
createdAt
required
string
deploymentId
required
string
domain
string | null
externalIp
string | null
id
required
string
internalUrl
string
internalUrls
Array<string>
name
required
string
nodePort
number | null
port
required
number
ports
Array<object>
object
id
required
string
name
string | null
nodePort
number | null
port
required
number
protocol
required
string
publicAddress
string | null
publicEnabled
boolean
publicPort
number | null
publicStatus
object
addresses
required
Array<string>
reason
required
string | null
state
required
string
Allowed values: ready pending failed unknown
serviceId
required
string
targetPort
required
number
key
additional properties
protocol
required
string
targetPort
required
number
type
required
string
Allowed values: internal external ingress
updatedAt
required
string
key
additional properties
specReplicas
number | null
startCommand
string | null
startupEnabled
boolean
startupFailureThreshold
number
status
required
string
stopped
required
boolean
tailscaleExposed
boolean
tailscaleHostname
string | null
templateInstanceId
string | null
totalCpuUsage
required
number | null
totalMemoryUsage
required
number | null
updatedAt
required
string
volumes
Array<object>
object
createdAt
string
deploymentId
string
hostPath
string | null
id
required
string
mountPath
required
string
name
required
string
pvcName
string | null
readOnly
required
boolean
storageSize
string | null
type
required
string
Allowed values: pvc hostPath emptyDir
updatedAt
string
key
additional properties
warnings
required
Array<object>
object
message
string
podName
string
timestamp
string
key
additional properties
key
additional properties

Example

{
"builderOverride": "firecracker",
"buildType": "dockerfile",
"deployStrategy": "rollingUpdate",
"effectiveImagePullPolicy": "Always",
"imagePullPolicy": "Always",
"ingresses": [
{
"protectionMode": "none",
"redirectStatus": 301,
"service": {
"ports": [
{
"publicStatus": {
"state": "ready"
}
}
],
"type": "internal"
}
}
],
"pods": [
{
"containers": [
{
"state": "running"
}
]
}
],
"rollout": {
"state": "stable"
},
"services": [
{
"ports": [
{
"publicStatus": {
"state": "ready"
}
}
],
"type": "internal"
}
],
"volumes": [
{
"type": "pvc"
}
]
}